Attribute VB_Name = "modApi"
Option Explicit
DefInt A-Z

Public Type NOTIFYICONDATA
    cbSize As Long
    hwnd As Long
    uId As Long
    uFlags As Long
    uCallBackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

Public nid() As NOTIFYICONDATA
Public oForms() As New frmPlay

Public Const NIM_ADD = &H0
Public Const NIM_MODIFY = &H1
Public Const NIM_DELETE = &H2

Public Const NIF_MESSAGE = &H1
Public Const NIF_ICON = &H2
Public Const NIF_TIP = &H4

Public Const WM_MOUSEMOVE = &H200

' Konstanten fr linke Maustaste
Public Const WM_LBUTTONDBLCLK = &H203   ' Doppelklick
Public Const WM_LBUTTONDOWN = &H201     ' Maus gedrckt
Public Const WM_LBUTTONUP = &H202       ' Maus losgelassen

' Konstanten fr rechte Maustaste
Public Const WM_RBUTTONDBLCLK = &H206   ' Doppelklick
Public Const WM_RBUTTONDOWN = &H204     ' Maus gedrckt
Public Const WM_RBUTTONUP = &H205       ' Maus losgelassen

Public Const KEYEVENTF_KEYUP = &H2
Public Const VK_LWIN = &H5B

Public Declare Function Shell_NotifyIcon Lib "shell32" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, pnid As NOTIFYICONDATA) As Boolean

' let's rest a bit
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Integer)
' is xmplay running?
Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long

Global sIconINIFile As String

' Create sys tray icon
Public Sub IconInSysTray(FormName As Form)
    Dim i As Integer
    i = UBound(nid) + 1
    ReDim Preserve nid(0 To i) 'Count up
    'Add an icon
    With nid(i)
        .cbSize = Len(nid(i))
        .hwnd = FormName.hwnd
        .uId = vbNull
        .uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
        .uCallBackMessage = WM_MOUSEMOVE
        .hIcon = FormName.Icon
        .szTip = FormName.Caption & vbNullChar
    End With
    Shell_NotifyIcon NIM_ADD, nid(i)
End Sub

' start!
Public Sub Main()
    On Error Resume Next
    If Dir(App.Path & "\start.vbs") <> "" Then
        Sleep 100
        Kill App.Path & "\start.vbs"
    End If
    
    Dim ff As Integer
    ff = FreeFile
    If Dir(App.Path & "\xmptray.cfg") <> "" Then
        Open App.Path & "\xmptray.cfg" For Input As ff
            Input #ff, sIconINIFile
        Close ff
    End If
    If sIconINIFile = "" Or Dir(sIconINIFile) = "" Then
        'Standard file
        sIconINIFile = App.Path & "\black and white.ini"
    End If
    
    If InStr(sIconINIFile, "\") = 0 And InStr(sIconINIFile, "/") = 0 Then
        'Add path if neccessary
        sIconINIFile = App.Path & "\" & sIconINIFile
    End If
    
    If Command <> "idle" Then
        'options
        frmConfig.Show vbModal
        End
    End If
        
    If App.PrevInstance Then End 'Don't show the icons twice
    
    ReDim nid(0)     ' 0 index is required
    ReDim oForms(0)  ' dito
    Unload oForms(0) ' ...but unload the form as it's not necessary!
    
    ' read icon file
    ff = FreeFile
    Dim sText As String, sTextSplit() As String
    Open sIconINIFile For Input As ff
        While Not EOF(ff)
            Line Input #ff, sText
            sTextSplit = Split(sText, ",")
            Select Case UBound(sTextSplit)
                Case 0 'only icon file specified
                    AddForm "", sTextSplit(0), "", ""
                Case 1 '... + icon description
                    AddForm sTextSplit(1), sTextSplit(0), "", ""
                Case 2 '... + left button action
                    AddForm sTextSplit(1), sTextSplit(0), "key" & sTextSplit(2), ""
                Case Else '... + right button action
                    AddForm sTextSplit(1), sTextSplit(0), "key" & sTextSplit(2), "key" & sTextSplit(3)
            End Select
        Wend
    Close ff
End Sub

' add a form
Public Sub AddForm(sIconTitle As String, sIconFile As String, Optional sLeftButtonAction As String = "", Optional sRightButtonAction As String = "")
    Dim i As Integer
    i = UBound(oForms) + 1
    ReDim Preserve oForms(0 To i) 'Count up
    
    If InStr(sIconFile, "\") = 0 And InStr(sIconFile, "/") = 0 Then
        sIconFile = Left(sIconINIFile, InStrRev(sIconINIFile, "\")) & sIconFile
    End If
    
    oForms(i).Init sIconTitle, sIconFile, sLeftButtonAction, sRightButtonAction, (i = 1)
End Sub

' exit!
Public Sub Destructor()
    RemoveIcons

    'Unload forms
    Dim oForm As Form
    For Each oForm In Forms
        Unload oForm
    Next
    End
End Sub

Public Sub RemoveIcons()
    'Remove icons
    Dim i As Integer
    For i = 1 To UBound(nid)
        Call Shell_NotifyIcon(NIM_DELETE, nid(i))
    Next i
    
    ReDim nid(0)
End Sub
